// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
 *
 * \brief
 *		OWI.cpͯ ̧
 *
 *		߰ݸ1-Wire(R)ײނŎgp`܂݂܂B
 *
 * \par pLq:
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *		uAVR318 - Dallas 1-Wire(R)呕uvɊPK
 *
 * \par 
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com \n
 *		Original author: \n
 *
 * $Name$
 * $Revision: 2335 $
 * $RCSfile$
 * $URL: http://revisor.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/OWI.h $
 * $Date: 2007-09-07 10:11:19 +0200 (fr, 07 sep 2007) $\n
****************************************************************************/

#ifndef OWI_H
#define OWI_H

#include <ioavr.h>

//******************************************************************************
// CRC֐p`
//******************************************************************************
#define		OWI_CRC_OK		0x00	//!< CRC
#define		OWI_CRC_ERROR	0x01	//!< CRC

//******************************************************************************
// P̪(OWI)p`
//******************************************************************************
/*! \brief CPUۯg
 *
 * ̒`Ϳĳ݂̂ײނgp鎞ɒxvẐɎgp܂B
 * ŒZx𐶐邽߂CPUg͍Œ2.170MHzłȂ΂Ȃ܂B
 */
#define		CPU_FREQUENCY	8.000

/*! \brief P޽ł̓ٱߒR̎gp
 *
 * ̼ق`ꂽꍇA޽ŕKvٱ߂𐶐̂ɁAAVR̔ėpo
 * ݏ̓ٱߒRgp܂BOٱߒRgpȂA̒
 * `𒍎߂ɂĂB
 */
//#define	OWI_USE_INTERNAL_PULLUP

// P(1-Wire)޽p߰Č`Ԑݒڼ޽
// 3ڼ޽SĂ߰ĂɑƂmɂĂB
#define		OWI_PORT	PORTA	//!< 1-Wire߰ďoڼ޽
#define		OWI_PIN		PINA	//!< 1-Wire߰ēڼ޽
#define		OWI_DDR		DDRA	//!< 1-Wire߰ĕڼ޽

//******************************************************************************
//  ޯĎՕl
//******************************************************************************
#define		OWI_PIN_0	0x01
#define		OWI_PIN_1	0x02
#define		OWI_PIN_2	0x04
#define		OWI_PIN_3	0x08
#define		OWI_PIN_4	0x10
#define		OWI_PIN_5	0x20
#define		OWI_PIN_6	0x40
#define		OWI_PIN_7	0x80

//******************************************************************************
// ݸ Ұ
//******************************************************************************
#define		OWI_DELAY_OFFSET_CYCLES	13	//! ޽LowɈ̂޽J鎞̒xݸ

// ۯłޯ ݸޒx(=s~MHzł̸ۯg)
#define		OWI_DELAY_A_STD_MODE	(unsigned long)((  6*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_B_STD_MODE	(unsigned long)(( 64*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_C_STD_MODE	(unsigned long)(( 60*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_D_STD_MODE	(unsigned long)(( 10*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_E_STD_MODE	(unsigned long)((  9*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_F_STD_MODE	(unsigned long)(( 55*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
//#define	OWI_DELAY_G_STD_MODE	(unsigned long)((  0*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_H_STD_MODE	(unsigned long)((480*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_I_STD_MODE	(unsigned long)(( 70*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)
#define		OWI_DELAY_J_STD_MODE	(unsigned long)((410*CPU_FREQUENCY)-OWI_DELAY_OFFSET_CYCLES)

//******************************************************************************
// ROM
//******************************************************************************
#define		OWI_ROM_READ	0x33	//!< READ ROMߕ
#define		OWI_ROM_SKIP	0xCC	//!< SKIP ROMߕ
#define		OWI_ROM_MATCH	0x55	//!< MATCH ROMߕ
#define		OWI_ROM_SEARCH	0xF0	//!< SEARCH ROMߕ

//******************************************************************************
// ߂蕄
//******************************************************************************
#define		OWI_ROM_SEARCH_FINISHED	0x00	//!< ߂蕄
#define		OWI_ROM_SEARCH_FAILED	0xFF	//!< s߂蕄

//******************************************************************************
// ϸ
//******************************************************************************
/*! \brief 1-Wire޽Low
 *
 * ϸۂ1-Wire݂̕o͂ɂĐLowɈ܂B
 *
 *  \param bitMask	LowɈ޽ޯĎՕl
 */
#define OWI_PULL_BUS_LOW(bitMask) \
			OWI_DDR |= (bitMask); \
			OWI_PORT &= ~(bitMask)

/*! \def OWI_RELEASE_BUS(bitMask)
 *
 * \brief ޽J
 *
 * ϸۂ޽JAꂪgpĂΓٱ߂܂B
 *
 * \param  bitMask	J޽ޯĎՕl
 */
#ifdef OWI_USE_INTERNAL_PULLUP		// 1-Wire݂͂ɐݒ肵ēٱߒR܂B
#define OWI_RELEASE_BUS(bitMask) \
			OWI_DDR &= ~(bitMask); \
			OWI_PORT |= (bitMask)
#else								// 1-Wire݂͂ɐݒ肵܂BٱߒR͋܂B
#define OWI_RELEASE_BUS(bitMask) \
			OWI_DDR &= ~(bitMask); \
			OWI_PORT &= ~(bitMask)

#endif

//******************************************************************************
// ֐^錾
//******************************************************************************
void OWI_SendByte(unsigned char data, unsigned char pins);
unsigned char OWI_ReceiveByte(unsigned char pin);
void OWI_SkipRom(unsigned char pins);
void OWI_ReadRom(unsigned char * romValue, unsigned char pin);
void OWI_MatchRom(unsigned char * romValue, unsigned char pins);
unsigned char OWI_SearchRom(unsigned char * bitPattern,
									 unsigned char lastDeviation, unsigned char pin);
void OWI_Init(unsigned char pins);
void OWI_WriteBit1(unsigned char pins);
void OWI_WriteBit0(unsigned char pins);
unsigned char OWI_ReadBit(unsigned char pins);
unsigned char OWI_DetectPresence(unsigned char pins);

unsigned char OWI_ComputeCRC8(unsigned char inData, unsigned char seed);
unsigned int OWI_ComputeCRC16(unsigned char inData, unsigned int seed);
unsigned char OWI_CheckRomCRC(unsigned char *romValue);

#endif // OWI_H

