/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		Ԋ֐
 *
 *		menu.hŒ`ꂽԂɊ֘A֐܂݂܂B\n
 *		Ⴆ΁AެߌAُ׸ސݒA"(x~)"Ɋ֘A֐܂݂
 *		B
 *
 *		\note Charge()Ԋ֐͂ꂪdr`ɊւėeՂɕύXׂȂ
 *		ŁAƗ̧قłB
 *
 * \par pLq
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com
 *
 * $Name$
 * $Revision: 2299 $
 * $RCSfile$
 * $URL: http://revisor.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/statefunc.c $
 * $Date: 2007-08-23 12:55:51 +0200 (to, 23 aug 2007) $\n
 ******************************************************************************/

#include <ioavr.h>
#include <inavr.h>
#include <stdlib.h>

#include "structs.h"
#include "enums.h"

#include "ADC.h"
#include "statefunc.h"
#include "battery.h"
#include "charge.h"
#include "main.h"
#include "menu.h"
#include "OWI.h"
#include "PWM.h"
#include "time.h"
#include "USI.h"

//******************************************************************************
// ϐ
//******************************************************************************
unsigned char ErrorFlags;	//!< \brief ُ׸ޕێ
							//!< \note ׸ނ̒`ɂĂstatefunc.hB
unsigned char ErrorState;	//! \brief ŌɈُ׸ނݒ肳ꂽԂێ
							//! \note Ԃ̒`ɂĂmenu.hB

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief 
 *
 * -  ۯOu1ɐݒ(8MHzs)
 * - P(1-Wire)̪
 * - ߏEEPROM
 * - dr݂o͂ƂĐݒAēdr֎~
 * - \ref SPIMODE ɏ]SPI
 * - A/Dϊ평
 * - /
 * - (A/DϊoR)̓dr͂drްǂݍ
 * - Ăѓdr֎~
 * - ݂̂̂ƂēdrAݒ(\ref BattActive=0)
 * - ُ׸(ErrorFlags)
 *
 * \param inp gp
 *
 * \retval ST_BATCON 菇ɉ鎟̏
 */
unsigned char Initialize(unsigned char inp)
{
	unsigned char i, page;

	__disable_interrupt();				// S̊荞݋֎~
	CLKPR = (1<<CLKPCE);				// CLKPSޯĕύX
	CLKPR = 0;							//  ۯOuȂ(8MHz ۯ)ݒ
	OWI_Init(OWIBUS);					// P1-Wire(R)̪
	// ߏEEPROM
	for (page = 0; page < 4; page++) {	// 4߰ޕ
		for (i = 0; i < 32; i++) {		// 1߰ޕ(32޲)
			BattEEPROM[page][i] = 0;	// Ή޲ď
		}
	}
	DDRB = (1<<PB4) | (1<<PB5);			// dr݂o͂ɐݒ
	DisableBatteries();					// dr֎~ݒ
	SPI_Init(SPIMODE);					// SPI
	ADC_Init();							// A/Dϊ평
	Time_Init();						// v평
	// drA/Dϊǂݎ(RIDް擾)̎
	for (i = 0; i < 2; i++)	{			// dr
		EnableBattery(i);				// Ήdr
		ADC_Wait();						// A/Dϊ񊮗ҋ@
		BatteryStatusRefresh();			// drԍXV
	}
	DisableBatteries();					// dr֎~
	BattActive = 0;						// drƂAw
	ErrorFlags = 0;						// ُ׸މ
	return(ST_BATCON);					// ̏ԂƋɕA
}

/*! \brief ެߐݒƓdrĕKvȂΏ[dJn
 *
 * ŏJumperCheck()Ă΂܂BȂA֐͉Lȓ`CHڑAK
 * vȂ΂̏[d݂邩ǂ𒲂ׂ܂B\n
 * [dKvȂȂA[d͎ST_SLEEP֍s܂B\n
 * JumperCheck()s܂͗LȓdrȂꍇST_ERRORłB̍Ō̏
 * łُ͈}܂B
 *
 * \param inp gp
 *
 * \retval ST_ERROR		ެߌs܂͗LȓdrȂ̏ꍇ̎̏
 * \retval ST_PREQUAL	drASɏ[dĂȂꍇ̎̏
 * \retval ST_SLEEP		drA[d̏ꍇ̎̏
 */
unsigned char BatteryControl(unsigned char inp)
{
	unsigned char i;

	if (!JumperCheck()) {											// ެߌs()ŁA
		return(ST_ERROR);											// ُԕƋɕA
	}
	if ((!BattControl[0].Enabled) && (!BattControl[1].Enabled)) {	// drŁA
		SetErrorFlag(ERR_NO_BATTERIES_ENABLED);						// ُ׸ސݒ

		return(ST_ERROR);											// ُԕƋɕA
	}
	for (i = 0; i < 2; i++) {										// dr
		if (BattControl[i].Enabled) {								// ΉdrLŁA
			EnableBattery(i);										// Ήdr
			ADC_Wait();												// A/Dϊ񊮗ҋ@
			if (BatteryStatusRefresh()) {							// drԍXVŁA
				if (!BattData.Charged) {							// [dς݂łȂ΁A
					BatteryDataRefresh();							// drްXV
					return(ST_PREQUAL);								// \[dԕƋɕA
				}
			}
		}
	}
	// ŏIȂA1܂2̓drASɏ[d܂B
	// 炪oȂ悤ɐؒfċx~(ذ)֍s܂B
	DisableBatteries();												// dr֎~
	return(ST_SLEEP);												// x~(ذ)ԕƋɕA
}

/*! \brief drł̑sJn
 *
 * \todo drd[ɍꍇɓdrős
 * \todo d臒lႭꍇɂ֔łB
 *
 */
unsigned char Discharge(unsigned char inp)
{
	return(ST_BATCON);	// drԕƋɕA(d񕜂ŏ[dJn)
}

/*! \brief ǂ炩̓dr[dKvƂ܂ŋx~(ذ)
 *
 * Doze()ĂсAċNŗ̓drɑ΂ďԂXV܂Bڑdr
 * Ƃ[dς݂ȂA֐͌JԂ܂BłȂ΁A֐ST_BATCON
 * ߂܂B
 *
 * \param inp gp
 *
 * \retval ST_BATCON ڑdr[dłȂꍇ̎̏
 */
unsigned char Sleep(unsigned char inp)
{
	unsigned char i;

	do {
		Doze();						// 8bԂx݂܂B
		// If any batteries need charging, go to ST_BATCON.
		// Otherwise, keep sleeping.
		for (i = 0; i < 2; i++) {	// dr
			EnableBattery(i);		// Ήdr
			ADC_Wait();				// A/Dϊ񊮗ҋ@
			if ((BatteryStatusRefresh()) && (!BattData.Charged)) {	// Ήdr[dς݂łȂ΁A
				return(ST_BATCON);	// drԕƋɕA
			}
		}
		DisableBatteries();			// dr֎~
	} while (TRUE);
}

/*! \brief 8b(VCC=5V)x
 *
 * A/Dϊ񊮗҂āAA/Dϊ֎~Aĳޯ ςpĖ8b
 * (VCC=5V)x~(ذ)܂BNオA/Dϊ͍ċ܂B
 */
void Doze(void)
{
	ADC_Wait();								// A/Dϊ񊮗ҋ@
	ADCS.Halt = TRUE;						// A/Dϊ~v׸ސݒ(݊Jn񊮗Œ~)
	ADCS.Flag = FALSE;						// A/Dϊ񊮗׸މ
	do {									// A/Dϊ񊮗ҋ@
	} while (ADCS.Flag == FALSE);
	WDTCR = (1<<WDP3)|(1<<WDP0);			// 5VŖ8b̳ޯތvlݒ
	WDTCR |= (1<<WDIF)|(1<<WDIE)|(1<<WDE);	// ޯފ荞ݗv׸މA荞݋Aޯދ
	MCUCR |= (1<<SE) | (1<<SM1)|(1<<SM0);	// x~ߋA޲`Ԏw
	__sleep();								// ޲x~`Ԉڍs(WDT荞݂ŋN)

	__watchdog_reset();						// ޯތv
	MCUSR &= ~(1<<WDRF);					// ޯ ؾ ׸މ
	WDTCR |= (1<<WDCE)|(1<<WDE);			// ޯޕύX
	WDTCR = 0;								// ޯދ֎~
	ADCS.Halt = FALSE;						// A/Dϊ֎~(Aϊ)
	ADCSRA |= (1<<ADEN)|(1<<ADSC);			// A/Dϊ틖AϊJn
	ADC_Wait();								// A/Dϊ񊮗ҋ@
}

/*! \brief ُ폈
 *
 * PWMo͂~ēdr֎~܂BĊ֐Doze()Ăяon߂JԂ
 * ֍sAĊȅُ݂܂B̌JԂ͑SĂ׸ނ
 * ŌJԂ܂B\n
 * [d͂̌ɍď܂B
 *
 * ެ߈ُ׸ނ̉ɂďAJumperCheck()Ăт܂Bs
 * ȂA܂Ăшُ׸ނݒ肳ł傤B\n
 *
 * LȓdrȂꍇALȓdr܂ŒPɌJԂ܂BĈُ
 * ނ͉܂B\n
 *
 * PWM܂͓drxُ̏ꍇ͒PɈُ׸ނ܂BDoze()
 * A܂͍ďɖ肪Ă邩ȂłB\n
 *
 * drՂĂꍇA\ref BattData ̏׸ނĈُ׸ނ
 * Oɓdr[d܂B
 *
 * \param inp gp
 */
unsigned char Error(unsigned char inp)
	{
	unsigned char i;

	PWM_Stop();				// [d(PWM)~
	DisableBatteries();		// dr֎~(Sאؒf)
	do {
		Doze();				// 8bԋx~
		for (i = 0x01; i!=0; i<<=1) {	// S׸ޏ
			if(i & ErrorFlags) {		// Ήُ׸ޗLŁA
				switch (i) {
				case  ERR_JUMPER_MISMATCH:			/* ެߕsv */
					ErrorFlags &= ~i;				// Ή׸މ
					JumperCheck();					// ެߍČ
				break;
				case  ERR_NO_BATTERIES_ENABLED:		/* drȂ */
					if ((BattControl[0].Enabled) || (BattControl[1].Enabled)) {		// ǂ炩̓drŁA
						ErrorFlags &= ~i;											// Ή׸މ
					}
				break;
				case  ERR_PWM_CONTROL:				/* PWMُ */
					ErrorFlags &= ~i;				// Ή׸މ
				break;
				case  ERR_BATTERY_TEMPERATURE:		/* drxُ */
					ErrorFlags &= ~i;				// Ή׸މ
				break;
				case  ERR_BATTERY_EXHAUSTED:		/* drՈُ */
					BattData.Exhausted = FALSE;			// dr׸މ
					BattActive = (BattActive + 1) % 2;	// ̓drLݒ(̓drŎs)
					ErrorFlags &= ~i;					// Ή׸މ
				break;
				default:
				break;
				}
			}
		}
	} while (ErrorFlags);
	return(ST_INIT);								// ԕƋɕA
}

/*! \brief w肳ꂽُ׸ނݒ肵Č݂̏Ԃۑ
 *
 * \ref ErrorFlags  \ref ErrorState XV܂B
 *
 * \note ُ׸ނstatefunc.hŎw肳܂B
 *
 * \param Flag ُ̈킪}邩w
 */
void SetErrorFlag(unsigned char Flag)
{
	ErrorFlags |= Flag;				// ُ׸ލXV
	ErrorState = CurrentState;		// ݂̏Ԃُ펞̏ԂƂĕۑ
}

/*! \brief ̼ެߌ
 *
 * SĂׂؒ̕fPWM\񂵁Ao͓d͓dƓ
 * ܂ޭè ق𑝉邱ƂɂĊ̼ެ߂܂BႢPWM
 * ޭèƕׂȂɉč~o͂0łׂŁAPWMޭèɈԏo
 * ֑͂fсA܂ɓ͓dƓȂł傤B֎~ASĂ̓d
 * r֎~ɒu܂B
 *
 * \retval FALSE	ެ߂܂ׂ͕sv̏ꍇ
 * \retval TRUE		SĂOK̏ꍇ
 */
unsigned char JumperCheck(void)
{
	DisableBatteries();			// dr֎~(ؒf)Aׂj󂳂邩܂!
	PWM_Start();				// PWMJn(~[d𐧌)
	Time_Set(TIMER_GEN,0,1,0);	// Ďvn((6~255)25000.62b蒷ׂł͂܂B)
	do {
		if (ADCS.rawVBAT == 1023) {		// A/DϊOaŁA
			PWM_Stop();					// PWM~
			return(FALSE);				// 蕄ƋɕA
		}
		if (abs((signed int)(ADCS.VIN - VIN_VBAT_DIFF_TYP - ADCS.VBAT)) <	// (VIN-VBAT)Ƒ\lԂ̐΍ݒ肵ő喢ŁA
		                     VIN_VBAT_DIFF_MAX ) {
			PWM_Stop();					// PWM~
			return(TRUE);				// 필ƋɕA
		}
		if (abs(ADCS.IBAT) > 100) {		// [ddŁA
			PWM_Stop();					// PWM~
			return(FALSE);				// 蕄ƋɕA(ׂJ405,406ެ߂𒲂ׂĂB)
		}
		if (!PWM_IncrementDutyCycle()) {	// PWMo͂[łȂȂA
			PWM_Stop();					// PWM~
			return(FALSE);				// 蕄ƋɕA(J400`404,407,408ެ߂𒲂ׂĂB)
		}
		
		ADC_Wait();						// A/Dϊ񊮗ҋ@
	} while (Time_Left(TIMER_GEN));		// 0.62bԌp
	PWM_Stop();						// PWM~
	return(FALSE);					// 蕄ƋɕA
}
