/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		drް擾Ɋ֘A֐
 *
 *		dr/֎~ȀԂA/DϊpdlT֐܂݂
 *		B
 *
 * \par pLq:
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Name$
 * $Revision: 4254 $
 * $RCSfile$
 * $URL: http://revisor.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/battery.c $
 * $Date: 2008-07-25 12:32:45 +0200 (fr, 25 jul 2008) $\n
 ******************************************************************************/

#include <ioavr.h>
#include <inavr.h>

#include "structs.h"
#include "enums.h"

#include "ADC.h"
#include "battery.h"
#include "main.h"
#include "OWI.h"
#include "time.h"

#ifdef NIMH
#include "NIMHspecs.h"
#endif // NIMH

#ifdef LIION
#include "LIIONspecs.h"
#endif // LIION

//******************************************************************************
// ϐ
//******************************************************************************
/* drp\ */
/*! \brief drp̐ްێ
 * \note Stored in EEPROM.
 */
__eeprom Battery_t BattControl[2] = {{TRUE, TRUE, FALSE},
                                     {TRUE, TRUE, FALSE}};

/* drpް\ */
Batteries_t BattData;	//!< ݂̓drpްێ

/* dCEPROMpL */
/*! \brief dr̂EPROMްpL̈
 * \note EEPROMɊi[
 */
__eeprom unsigned char BattEEPROM[4][32];

//! ݂̓drS̕ϐ(0=drA,1=drB)
unsigned char BattActive;

/*! \brief RIDQƕ\
 *
 * Ǝ҂ɂĎw肳ꂽo^ID܂݂܂B
 *
 * \note ĺ}15%eƂ̉ŌvZĂ܂B
 */
const __eeprom RID_Lookup_t RID[RID_TABLE_SIZE] = {
  {558, 659, 3900, 550, 260, 300, 10},
  {744, 843, 6800, 750, 360, 300, 14},
  {869, 958, 10000, 1000, 475, 300, 19},
  {1097, 1153, 24000, 2000, 475, 420, 38}
};

/*! \brief NTCQƕ\
 *
 * 擪0łBeiKŉx4܂B20iKōŌ(20-1)~4=76łB\n
 * A/Dϊl~Ő񂳂Ȃ΂Ȃ܂B
 *
 * \note NTCLookUp()͂̕\ȉ̂悤ɕύXꂽꍇɏCȂ΂Ȃ
 * ܂B
 * - 擪͂0ł͂ȂB
 * - iKԂ̉x͂4ł͂ȂB
 * - A/Dϊl͂w肵0.5A/DϊiKʒlłȂB
 */
// Varta PolyFlex NTCp
const NTC_Lookup_t NTC[NTC_TABLE_SIZE] = {
	{1002, 23}, {953, 25}, {902, 26}, {849, 27}, {796, 27},
	{742, 27}, {689, 26}, {637, 26}, {587, 25}, {539, 24},
	{494, 22}, {451, 21}, {412, 19}, {375, 18}, {341, 17},
	{310, 15}, {282, 14}, {256, 13}, {233, 11}, {212, 10}
};

// OHNTCp
/*
const NTC_Lookup_t NTC[NTC_TABLE_SIZE] = {
  {1004, 24}, {954, 25}, {903, 26}, {850, 27}, {796, 27},
  {742, 27}, {689, 27}, {637, 26}, {587, 25}, {539, 24},
  {493, 22}, {451, 21}, {411, 20}, {374, 18}, {340, 17},
  {309, 15}, {281, 14}, {255, 13}, {232, 11}, {211, 10}
};
*/

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief drύX
 *
 * deʂۑAēdrԂ̍XV݂܂B\n
 * XVȂAeʂVƔr܂B
 * 
 * \retval FALSE	drؒf܂͗eʕύX
 * \retval TRUE		SOK
 */
unsigned char BatteryCheck(void)
{
	unsigned char success = TRUE;
	unsigned int  oldCapacity;

	oldCapacity = BattData.Capacity;		// dreʂƂĕۑ
	if (!BatteryStatusRefresh()) {			// drXVŁA
		success = FALSE;					// drs݂܂RIDw(OK׸މ)
	}

	if (oldCapacity != BattData.Capacity) {	// VeʕsvŁA
		success = FALSE;					// dr`ԐݒύXw(OK׸މ)
	}
	return(success);						// /ύX׸ނƋɕA
}

/*! \brief drԏXV
 *
 * ݂ȂA(A/Dϊɂǂݎ)RIDNTCɊāAdrԏXV
 * ܂B\n
 * ĂяoOɁAdrASA/Dϊް̑gWĂȂ΂
 * ܂B\n
 *
 * \retval FALSE	drs
 * \retval TRUE		dr݁AԍXV
 *
 * \note ALLOW_NO_RID`ĂꍇAQƕ\œKڂSȂꍇ
 * [d~܂BɊdrްgp܂B
 */
unsigned char BatteryStatusRefresh(void)
{
	unsigned char success = FALSE;	// l͍ň

	BattData.Present = FALSE;
	BattData.Charged = FALSE;
	BattData.Low = TRUE;
	BattData.Circuit = OW_NONE;
	BattData.Temperature = 0;
	BattData.Capacity = 0;
	BattData.MaxCurrent = 0;
	BattData.MaxTime = 0;
	BattData.MinCurrent = 0;

	NTCLookUp();
	BattData.HasRID = RIDLookUp();
	if (ADCS.VBAT >= BAT_VOLTAGE_MIN) {		// drdŏSٓdŁA
		BattData.Low = FALSE;				// Œd׸މ
	}
	if (ADCS.VBAT >= BAT_VOLTAGE_LOW) {		// drd[ddŁA
		BattData.Charged = TRUE;			// [dς׸ސݒ
	}

	// [dȂꍇAVBATSxȏȂAdr͑݁B
	// [dꍇAd̗ꂪȂAdr͑݁B

	/*! \todo ABORT_IF_PWM_MAX`ĂꍇA̓dr݌̍ŏI
	* ͍őޭè قł̒Ⴂd̂߂ɏ[d~Ă̂ŁA璷łB
	* ͏[ddǂݍ݂100%ۏ؂łȂߖ]܂ƂłB
	*/
	if (((OCR1B == 0) && (!BattData.Low)) ||
		((OCR1B != 0) && (ADCS.avgIBAT > 0))) {
		BattData.Present = TRUE;
		success = TRUE;
	} else {
		BattData.Low = FALSE;	// (͂ƐI`Ł`)
		success = FALSE;
	}
#ifndef ALLOW_NO_RID
	if(!BattData.HasRID) {	// LȑΉRIDڂȂ΁A
		success = FALSE;	// [d~邽߂ɁA׸މ
	}
#endif
	return(success);
}

/*! \brief EEPROM̓drްXV
 *
 * drEPROMeX32޲Ă4߰ނǂ݁AްߏEEPROMɊi[
 * ܂B\n
 * łȂ(CRCُ)AߏEEPROM͍Xɂ܂B
 *
 * \todo ްBattDataXV܂BdlKvłB
 *
 * \retval FALSE	XVs
 * \retval TRUE		XV
 */
unsigned char BatteryDataRefresh(void)
{
	unsigned char offset;
	unsigned char i, crc, family, temp, page;
	unsigned char success;

	for (page = 0; page < 4; page++) {		// eX32޲Ă4߰ނ
		success = FALSE;
		if (OWI_DetectPresence(OWIBUS) == OWIBUS) {	// ݌oŁA`CRC
			OWI_SendByte(OWI_ROM_READ, OWIBUS);
			family = OWI_ReceiveByte(OWIBUS);
			crc = OWI_ComputeCRC8(family,0);
			for (i = 0; i < 6; i++) {
				crc = OWI_ComputeCRC8(OWI_ReceiveByte(OWIBUS),crc);
			}
			if (OWI_ComputeCRC8(OWI_ReceiveByte(OWIBUS),crc) == 0) {	// CRCAu
				BattData.Circuit = family;
				if (BattData.Circuit == OW_DS2505) {	// DS2505 EPROMްǂݍ
					offset = page*32;
					OWI_SendByte(DS2505_DATA_READ, OWIBUS);	// : ްǂݍ
					OWI_SendByte(offset, OWIBUS);			// ް: ڽ
					OWI_SendByte(0, OWIBUS);				// ް: ڽ
					crc = OWI_ComputeCRC8(DS2505_DATA_READ,0);	// ьvZ
					crc = OWI_ComputeCRC8(offset,crc);
					crc = OWI_ComputeCRC8(0,crc);

					if (OWI_ComputeCRC8(OWI_ReceiveByte(OWIBUS),crc) == 0) {	// ߎMŁA
						crc = 0;
						for (i=0; i<32; i++) {					// 1߰(32޲)ްǂݍ
							temp = OWI_ReceiveByte(OWIBUS);
							crc = OWI_ComputeCRC8(temp, crc);
							BattEEPROM[page][i] = temp;
						}

						if (OWI_ComputeCRC8(OWI_ReceiveByte(OWIBUS),crc) == 0) {
								success = TRUE;										// ׸ސݒ
						}
					} else {	// ްǂݍݖߎs(ްǂݍݕs\)
					}
				} else {	// sȑu`
				}
			} else {	// uo
			}
		} else {	// P޽o݂Ȃ
		}

		if (!success) {	// ꂩُ̈ߓEEPROMۑ揉
			for (i=0; i<32; i++) {
				BattEEPROM[page][i] = 0;
			}
		}
	}
	return(success);
}

/*! \brief wdr
 *
 * \ref BattActive w肵drɍXVAĂǂ̓drw肳ꂽɈ
 * āA߰BPB4/PB5ݒ肵PB5/PB4܂B\n
 * ̊֐߰Đ؂ւ̂Ɉ̂߂100ms܂B
 *
 * \param bat	ǂ̓dr邩w(0=drA,1=drB)
 */
void EnableBattery(unsigned char bat)
{
	Time_Set(TIMER_GEN,0,0,100);	// Sʌv100msɐݒ
	BattActive = bat;				// wdrƂĐݒ
	PORTB |= (1 << (PB4+bat));		// drALED_Adrڑ
	PORTB &= ~(1<<(PB5-bat));		// ̓dqؒf
	do {							// ؂ւ莞ԑҋ@
	} while (Time_Left(TIMER_GEN));
}

/*! \brief dr֎~
 *
 * ߰BPB4PB5ėdr֎~܂B
 */
void DisableBatteries(void)
{
	PORTB &= ~((1<<PB4)|(1<<PB5));	// drؒfALED
}

/*! \brief RID\drް
 *
 * RIDQƕ\drpް݂܂B\n
 * Ȃꍇ(battery.hŒ`ꂽ)ްgp܂B
 *
 * \retval TRUE		AdrްXV
 * \retval FALSE	Adrްpgp
 */
unsigned char RIDLookUp (void)
{
	unsigned char i, found = FALSE;

	for (i = 0 ; i < RID_TABLE_SIZE; i++) {	// RIDQƕ\
		if (ADCS.rawRID >= RID[i].Low) {		// ΉډlȏŁA
			if (ADCS.rawRID <= RID[i].High) {		// Ήڏlȉ(Ήڒl͈͓)ŁAdrްXV
				BattData.Capacity = RID[i].Capacity;
				BattData.MaxCurrent = RID[i].Icharge;
				BattData.MaxTime = RID[i].tCutOff;
				BattData.MinCurrent = RID[i].ICutOff;
				found = TRUE;
			}
		}
	}
	if (!found) {	// ŁAdrްްōXV
		BattData.Capacity = DEF_BAT_CAPACITY;
		BattData.MaxCurrent = DEF_BAT_CURRENT_MAX;
		BattData.MaxTime = DEF_BAT_TIME_MAX;
		BattData.MinCurrent = DEF_BAT_CURRENT_MIN;
	}
	return(found);
}

/*! \brief Qƕ\牷xvZ
 *
 * lɓ܂͂ȉ̍őNTClT܂B\n
 * ݂̎Qƕ\ł͉xŌvZ܂B\n
 * 4~(\̎wW)-2~(肳ꂽNTC-̍łNTC)(̍ADCsteps)
 *
 * \note NTC肪Oa(A/DϊNTCQƕ\̐擪̓(l)傫Ȍʂ
 * ^)ꍇAx͕Ƃĕ񍐂܂B
 *
 * \note ȂꍇAdrx \ref NTC_MAX_TEMPERATURE ɐݒ肳
 * B
 */
void NTCLookUp (void)
{
	unsigned char i;
	unsigned char found = FALSE;

	for (i=0 ; (i < NTC_TABLE_SIZE) && (!found); i++) {	// Qƕ\
		if (ADCS.rawNTC >= NTC[i].ADC) {				// ΉŁAxl擾
			BattData.Temperature = (i<<2) ;
			BattData.ADCSteps = NTC[i].ADCsteps;  
			BattData.Temperature -= ( ( (signed int)ADCS.rawNTC			// BattData.Temperature͕tŁǍvZ̊e͕ȂłB
									 - (signed int)NTC[i].ADC ) << 1	// ׂ߲̈Ŝ߂ɷĂ܂B
								) / (signed int)BattData.ADCSteps;

			found = TRUE;	// (breakŏI邱Ƃo܂AMISRAᔽłB)
		}
	}
	if (!found) {	// Ŝ߁AdrxNTCQƕ\(l)傫ꍇɒ`ꂽőlݒ肵܂B
		BattData.Temperature = NTC_MAX_TEMPERATURE;
	}
}
