/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		/]uŋʂ\
 *
 *		ADC.cbattery.cp̍\̐錾܂݂܂B\n
 *		͎呕ułgpÂɗ֐̂߂ɓƗ̧قɒu܂B
 *
 * \par pLq
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com \n
 *
 * $Name$
 * $Revision: 4254 $
 * $RCSfile$
 * $URL: http://revisor.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/structs.h $
 * $Date: 2008-07-25 12:32:45 +0200 (fr, 25 jul 2008) $\n
 ******************************************************************************/

#ifndef STRUCTS_H
#define STRUCTS_H

//******************************************************************************
// dr\̐錾
//******************************************************************************
/*! \brief drɊւԂƕϐްێ
 *
 * ްBatteryStatusRefresh(),RIDLookUp(),NTCLookUp()
 * BatteryDataRefresh()ɂčXV܂B
 */
struct Batteries_struct
{
	unsigned char	Present		: 1;	//!< dr(TRUE/FALSE)
	unsigned char	Charged		: 1;	//!< dr[d(TRUE/FALSE)
	unsigned char	Low			: 1;	//!< drd(TRUE/FALSE)
	unsigned char	Exhausted	: 1;	//!< dr(TRUE/FALSE)
	unsigned char	HasRID		: 1;	//!< o^IDL(TRUE/FALSE)
	unsigned char	Circuit;			//!< drSH(nID)
	signed char		Temperature;		//!< drx()
	unsigned char	ADCSteps;			//!< 0.5A/DϊiKl
	unsigned int	Capacity;			//!< mAhł̗e
	unsigned int	MaxCurrent;			//!< mAł̏[dd
	unsigned int	MaxTime;			//!< ł̍ő[d
	unsigned int	MinCurrent;			//!< mAł̏[d~d
};
typedef struct Batteries_struct Batteries_t;	//!< ֐̂

//! \brief drp̐ްێ
struct Battery_struct
{
	unsigned char	Enabled				: 1;	//! drL(v)(TRUE/FALSE)
	unsigned char	DisconnectAllowed	: 1;	//! ؒfv(TRUE/FALSE)
	unsigned char	ChargeInhibit		: 1;	//! [d֎~(TRUE/FALSE) \todo 呕uɂ[d?
};
typedef struct Battery_struct Battery_t;		//!< ֐̂

//******************************************************************************
// A/Dϊԍ\̐錾
//******************************************************************************
/*! \brief A/Dϊ󋵂Ǝێ
 *
 * ADC_ISR()ɂčXV܂B
 */
struct ADC_Status_struct
{
	unsigned char	MUX			: 5;	//!< ADMUX̉ޯ(MUX4`0)ɑΉ
	unsigned char	Flag		: 1;	//!< A/Dϊ񊮗 (TRUE/FALSE)
	unsigned char	Mains		: 1;	//!< dOK? (TRUE/FALSE)
	unsigned char	Halt		: 1;	//!< A/Dϊ~v (TRUE/FALSE)
	unsigned char	ADC3_G20_OS	: 4;	//!< 20{łADC3ψ(̾)
	unsigned char	ADC5_G20_OS	: 4;	//!< 20{łADC5ψ(̾)
	unsigned int	rawRID;				//!< o^IDް
	unsigned int	rawNTC;				//!< нް
	unsigned int	rawVBAT;			//!< drdް
	unsigned int	VIN;				//!< mVł̋d
	unsigned int	VBAT;				//!< mVł̓drd
	signed int		IBAT;				//!< mAł̓drd
	signed int		discIBAT[4];		//!< mAł̓drdɏՕ(ωp)
	signed int		avgIBAT;			//!< mAł̕ϓdrd(ŏI4̎̕)
};
typedef struct ADC_Status_struct ADC_Status_t; //!< ֐̂

//******************************************************************************
// [dpҰ\
//******************************************************************************
/*! \brief ConstantCurrent()ConstantVoltage()pҰێ
 *
 */
struct ChargeParameters_struct {
	unsigned int Voltage;			//!< [dd
	unsigned int Current;			//!< [dd
	unsigned char NextState;		//!< \brief [diK̎̏
									//!< \note Charge()Őݒ肳܂Aُ픭̏ꍇHaltNow()ɂĕύX邩܂B
};
typedef struct ChargeParameters_struct ChargeParameters_t;

//******************************************************************************
// HaltNow()pҰ\
//******************************************************************************
/*! \brief HaltNow()pҰێ
 *
 */
struct HaltParameters_struct {
	unsigned char HaltFlags;		//! \brief ]p׸ނ܂݂܂B
									//! \note e׸ނ̒`ɂĂchargefunc.hB
	unsigned int VoltageDrop;		//! ~O̓dɉmVł̍őቺ
	unsigned int VoltageMax;		//! mVł̏o͓d
	unsigned int CurrentMin;		//! mAł̏o͓d
	signed int TemperatureMax;		//! ł̓drx
	signed int TemperatureMin;		//! ł̓drx
	unsigned int TemperatureRise;	//! ́ł̉x㏸
	unsigned int VBATMax;			//! \brief dቺvZɎgp鑪ōVBAT܂݂܂B
									//! \note 蓮ŉȂ΂Ȃ܂B
	unsigned int LastNTC;			//! x㏸oɎgp
};
typedef struct HaltParameters_struct HaltParameters_t;

#endif // STRUCTS_H
